﻿
Partial Class Cart
    Inherits System.Web.UI.Page

    ' A helper function to display the basket items in GridView1.
    Private Sub UpdatePage()
        Try
            Using carEntities As New CarEntities()
                Dim BasketNum As Integer
                BasketNum = CInt(Session("BasketNum"))
                'Dim query = From CarBasketItem In carEntities.CarBasketItems _
                '    Where (CarBasketItem.BasketNum = ________________) _
                '    Select CarBasketItem.BasketItemProdName, CarBasketItem.BasketItemQuantity, _
                '        CarBasketItem.BasketItemPrice, CarBasketItem.BasketItemTotal Order By BasketItemProdName

                If query.Count() > 0 Then
                    'GridView1.DataSource = ___________________________
                    GridView1.DataBind()   '*** Optional: Can you find a way to add the BrandName to the grid view?
                    GridView1.Visible = True
                    BuyButton.Visible = True
                    EmptyButton.Visible = True

                    Dim Total As Decimal = 0
                    Dim NumCars As Decimal = 0
                    For Each CarBasketItem In query
                        Total = Total + CarBasketItem.BasketItemTotal
                        NumCars = NumCars + CarBasketItem.BasketItemQuantity
                    Next CarBasketItem

                    SubtotalLabel.Text = "Subtotal (before tax & shipping): " & String.Format("{0:C}", Total)
                    If NumCars = 1 Then
                        NumItemsLabel.Text = "1 item in cart"
                    Else
                        NumItemsLabel.Text = NumCars.ToString & " items in cart"
                    End If
                Else
                    ErrorLabel.Text = "No items in cart"
                    ErrorLabel.Visible = True
                    GridView1.Visible = False
                    SubtotalLabel.Visible = False
                    NumItemsLabel.Visible = False
                    BuyButton.Visible = False
                    EmptyButton.Visible = False
                End If
            End Using
        Catch exception As Exception
            ErrorLabel.Text = "Error on page"
            ErrorLabel.Visible = True
        End Try
    End Sub

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        'Code to handle shopper number #######
        Dim ErrorFlag As Integer
        Dim CurrentTime As String
        Dim SessionShopperNum As String
        ShopperErrorLabel.Visible = False
        ErrorFlag = 0
        CurrentTime = System.DateTime.Now.Ticks.ToString

        Try
            SessionShopperNum = Session("ShopperNum")
            If (SessionShopperNum Is Nothing) OrElse (SessionShopperNum = "0") Then
                Using carEntities As New CarEntities()
                    Dim S As New CarShopper With {.ShopperLastName = CurrentTime, _
                    .ShopperFirstName = "", .ShopperStreet = "", .ShopperCity = "", .ShopperZipCode = "", _
                    .ShopperState = "", .ShopperPhone = "", .ShopperEmail = ""}   ' temporary name for now
                    carEntities.CarShoppers.Add(S)
                    carEntities.SaveChanges()

                    'One technique for finding the ID of the inserted item.  For another way, see AddToCart
                    'click handler in Results.aspx.vb when it inserts a new basket.
                    Dim Match = From CarShopper In carEntities.CarShoppers _
                       Select CarShopper Where (CarShopper.ShopperLastName = CurrentTime)
                    Session("ShopperNum") = Match.FirstOrDefault.ID
                End Using
            End If
        Catch exception As Exception
            ErrorFlag = 1
        End Try

        If ErrorFlag = 1 Then
            ShopperErrorLabel.Visible = True
        End If
        'End of code to handle shopper number #######
        ' Note use of Nothing in test below:
        If Session("BasketNum") Is Nothing Then   ' Basket has not been set up. User did not take proper route to this page.
            ErrorLabel.Text = "No shopping cart"
            ErrorLabel.Visible = True
        Else
            UpdatePage()
        End If
    End Sub

    Protected Sub BuyButton_Click(sender As Object, e As EventArgs) Handles BuyButton.Click
        If (ErrorLabel.Visible = False) And (ShopperErrorLabel.Visible = False) Then
            Response.Redirect("Shipping.aspx")
        End If
    End Sub

    Protected Sub EmptyButton_Click(sender As Object, e As EventArgs) Handles EmptyButton.Click
        Try
            Using carEntities As New CarEntities()
                Dim BasketNum As Integer
                BasketNum = CInt(Session("BasketNum"))
                'Dim query = From CarBasketItem In carEntities.CarBasketItems _
                '    Where (CarBasketItem.BasketNum = __________________) _
                '    Select CarBasketItem Order By CarBasketItem.BasketItemProdName

                ' Mark all of the objects in query results for removal.
                For Each CarBasketItem In query
                    carEntities.CarBasketItems.Remove(CarBasketItem)
                Next CarBasketItem

                carEntities._________________()   ' Make those removals permanent.
                Session.Remove("BasketNum")  'Will prevent the user from seeing the shipping page.  *** NEW ***
            End Using
        Catch exception As Exception
            ErrorLabel.Text = "Error on page"
            ErrorLabel.Visible = True
            ' ErrorLabel.Text = exception.Message  ' Uncomment this line to debug.
        End Try

        UpdatePage()   ' Will display an empty page with message that the cart is empty.
    End Sub

    Protected Sub GridView1_PageIndexChanging(sender As Object, e As GridViewPageEventArgs) Handles GridView1.PageIndexChanging
        GridView1.PageIndex = e.NewPageIndex   ' The one new line of code!
        UpdatePage()
    End Sub

    Protected Sub GridView1_RowDeleting(sender As Object, e As GridViewDeleteEventArgs) Handles GridView1.RowDeleting
        Dim BItemNum As Integer

        Try
            ' Find the index of the GridView1 row where the user clicked the button:
            Dim index As Int32 = Convert.ToInt32(e.RowIndex)   ' *** Would plain Integer work? ***
            Dim location As Int32 = GridView1.PageSize * GridView1.PageIndex + index

            Using carEntities As New CarEntities()
                Dim BasketNum As Integer
                BasketNum = CInt(Session("BasketNum"))
                'Dim query = From CarBasketItem In carEntities.CarBasketItems _
                '    Where (CarBasketItem.BasketNum = __________) _
                '    Select CarBasketItem Order By CarBasketItem.BasketItemProdName

                If query.Count() = 1 Then   'We are removing the last item from the basket.
                    Session.Remove("BasketNum")  'Will prevent the user from seeing the shipping page.  *** NEW ***
                End If

                ' Get the ID number for the basket item to be removed.
                BItemNum = query.Skip(location).Take(1).FirstOrDefault.ID
                ' Get the particular basket item object to be removed.
                Dim match = carEntities.CarBasketItems.Single(Function(U) U.ID = BItemNum)
                'carEntities.CarBasketItems.Remove(_________)   ' remove the particular basket item just found
                carEntities.SaveChanges()
            End Using
        Catch exception As Exception
            ErrorLabel.Text = "Error on page"
            ErrorLabel.Visible = True
            ' ErrorLabel.Text = exception.Message  ' Uncomment this line to debug.
        End Try

        'Go back to the first page as we may have removed the last item on the page already displayed.
        GridView1.PageIndex = 0
        UpdatePage()
    End Sub
End Class
