﻿
Partial Class Payment
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim Quantity, BasketNum, ShopperNum As Integer
        Dim Subtotal, Total, Tax, Shipping As Decimal
        Dim FirstName, LastName, Street, City, State, ZipCode, Phone, Email As String

        ErrorLabel.Visible = False
        BasketNum = CInt(Session("BasketNum"))
        ShopperNum = CInt(Session("ShopperNum"))
        FirstName = Session("FirstName")
        LastName = Session("LastName")
        Street = Session("Street")
        City = Session("City")
        State = Session("State")
        ZipCode = Session("Zipcode")
        Phone = Session("Phone")
        Email = Session("Email")

        If Not IsPostBack Then
            ' Make sure the user got here from a refresh of this page or from the shipping page:
            ' **** If you want to test your app locally, comment off this section until you
            ' **** have things working.  Then uncomment this section and publish your app to the
            ' **** live web server.  You MUST adjust the 2 URIs in this code to match your situation.
            ' **** For example, the carlsond would need to be changed, and the name of the store folder.

            'Note: If you change to using https, adjust the 2 URIs here:
            Try
                If (LCase(Request.UrlReferrer.AbsoluteUri) <> _
                    "http://cis2.stvincent.edu/carlsond/store3a/shipping.aspx") _
                    AndAlso (LCase(Request.UrlReferrer.AbsoluteUri) <> _
                    "http://cis2.stvincent.edu/carlsond/store3a/payment.aspx") Then
                    Response.Redirect("Cart.aspx")
                End If
            Catch exception As Exception
                Response.Redirect("Cart.aspx")
            End Try
            ' **** End of section to comment off when testing locally.

            Try
                ' Get the Quantity and Subtotal from the database
                Using carEntities As New CarEntities()
                    'Dim query = From CarBasketItem In carEntities.CarBasketItems _
                    '    Where (CarBasketItem.BasketNum = ________________) _
                    '    Select CarBasketItem.BasketItemProdName, CarBasketItem.BasketItemQuantity, _
                    '        CarBasketItem.BasketItemPrice, CarBasketItem.BasketItemTotal Order By BasketItemProdName

                    If query.Count() > 0 Then
                        Subtotal = 0
                        Quantity = 0
                        For Each CarBasketItem In query
                            Subtotal = Subtotal + CarBasketItem.BasketItemTotal
                            'Quantity = Quantity + CarBasketItem.________________
                        Next CarBasketItem
                        Session("Subtotal") = Subtotal
                        Session("Quantity") = Quantity
                    Else  'Cart is empty
                        Response.Redirect("Cart.aspx")
                    End If
                End Using
            Catch exception As Exception
                ErrorLabel.Visible = True
            End Try

            If Quantity = 0 Then   ' There is nothing to purchase.
                Response.Redirect("Cart.aspx")
            End If

            Shipping = Quantity * 125  ' Assumes a $125 shipping fee.  Adjust as needed.
            Tax = 0.06 * Subtotal  ' Assumes a 6% sales tax.  Adjust this as needed, perhaps based on the state.
            ' It would be helpful to have a web service that reports the tax rate when given the state.
            ' That way the code here would not have to be changed just because some state changed its tax rate.
            Total = Subtotal + Tax + Shipping
            Session("Shipping") = Shipping
            Session("Tax") = Tax
            Session("Total") = Total

            SubtotalLabel.Text = String.Format("{0:C}", Subtotal)
            ShippingLabel.Text = String.Format("{0:C}", Shipping)
            TaxLabel.Text = String.Format("{0:C}", Tax)
            TotalLabel.Text = String.Format("{0:C}", Total)
        Else   ' Postback case.  The user has clicked the Purchase button on the form.
            ' Save the information that's on the page into session state.
            ' Also, remove any - characters from the credit card number.
            'Session("NameOnCard") = ________________________
            Session("CardNumber") = Replace(CardNumberBox.Text, "-", "")  ' Drop - characters.
            Session("CardType") = CardTypeList.SelectedItem.Value
            Session("CardExpireDate") = CardExpireMonthList.SelectedItem.Value & "/" & _
                CardExpireYearList.SelectedItem.Value

            ' Here is where we would likely check to see if the credit card payment is accepted or not.
            ' If not, the user would be redirected to a page explaining that the purchase was denied.
            ' Perhaps an email explaining the denial would also be sent.
            ' Because of the redirection to the deny page, the data for this intended purchase does
            ' not get written to the Order, Payment, and Shopper tables, not does the corresponding row
            ' of the Basket table have the BasketOrderPlaced field value changed from 0 to 1.
            ' Thus the order will not get processed.  Most of the data for it is discarded, though
            ' the product details are still in the BasketItemTable.

            ' On your first attempt, leave out the call to this web service, so that all purchases are accepted
            ' with no credit check.  Once that works, call my web service. See the directions for this web
            ' store 3 project on how to set up a web reference in your web site to my web service as the directions
            ' may differ somewhat from what is in our text.  As our text says on page 468, you need
            ' to make a new proxy object for my web service CreditCheck.Credit().  After that you can use that
            ' proxy object to call my Authorize function to see if the purchase is authorized on this credit card.
            ' Note that this function takes 2 parameters, as its header shows:

            ' Public Function Authorized(ByVal CardNum As String, ByVal Amount As Decimal) As String

            ' The function returns the string "True" if the purchase is authorized and "False" otherwise.
            ' If the answer is "False", redirect the browser to the Deny.aspx page.  Otherwise continue on in this code.



            'Update the relevant data in the Basket and Shopper tables. Also add a new row to Order and Payment tables.
            'We could later use the Shopper table in the management app to send promotions to customers.
            'We could also use it to implement customer profiles so that returning customers
            'would not have to enter their address information.
            Try
                Using carEntities As New CarEntities()
                    'Dim query = From CarBasket In carEntities.CarBaskets _
                    '    Where CarBasket.BasketNum = ______________ Select CarBasket, CarBasket.CarShopper

                    Dim MatchBasket = query.FirstOrDefault.CarBasket
                    MatchBasket.BasketOrderPlaced = 1
                    MatchBasket.BasketNumItems = CInt(Session("Quantity"))
                    MatchBasket.BasketSubtotal = CDec(Session("Subtotal"))
                    MatchBasket.BasketTotal = CDec(Session("Total"))
                    MatchBasket.BasketShipping = CDec(Session("Shipping"))
                    MatchBasket.BasketTax = CDec(Session("Tax"))
                    'BasketNum and ShopperNum fields are already filled in.

                    Dim MatchShopper = query.FirstOrDefault.CarShopper
                    MatchShopper.ShopperFirstName = FirstName
                    MatchShopper.ShopperLastName = LastName   'This replaces the time that was used as a temporary name.
                    MatchShopper.ShopperStreet = Street
                    MatchShopper.ShopperCity = City
                    MatchShopper.ShopperState = State
                    MatchShopper.ShopperZipCode = ZipCode
                    MatchShopper.ShopperPhone = Phone
                    MatchShopper.ShopperEmail = Email
                    'ID field already has a value.

                    Dim Order As New CarOrder With {.ShopperNum = ShopperNum, .BasketNum = BasketNum, _
                       .OrderFirstName = FirstName, .OrderLastName = LastName, .OrderStreet = Street, _
                       .OrderCity = City, .OrderState = State, .OrderZipCode = ZipCode, .OrderPhone = Phone, _
                       .OrderEmail = Email, .OrderDateOrdered = DateString}
                    carEntities.CarOrders.Add(Order)
                    'carEntities._______________()   ' Save now so we can learn the order ID number.
                    Session("OrderNum") = Order.ID  ' Get order ID for the newly-placed order, save in Session state.

                    Dim Payment As New CarPayment With {.OrderNum = Order.ID, .PaymentCardType = Session("CardType"), _
                       .PaymentCardNumber = Session("CardNumber"), .PaymentExpirationDate = Session("CardExpireDate"), _
                       .PaymentCardOwnerName = Session("NameOnCard")}
                    carEntities.CarPayments.Add(Payment)
                    carEntities.SaveChanges()
                End Using
            Catch exception As Exception
                ErrorLabel.Visible = True
            End Try

            'The next step is typically to send an email confirmation to the customer
            'and to present a page confirming the order:
            Response.Redirect("Confirm.aspx")
        End If
    End Sub
End Class
